from pprint import pprint as pp
import json
import requests
import urllib.parse


auth = open('auth.txt', 'r', encoding='utf-8').readline()
headers = {
    'sec-ch-ua': '"Google Chrome";v="105", "Not)A;Brand";v="8", "Chromium";v="105"',
    'sec-ch-ua-mobile': '?0',
    'Authorization': auth,
    # Already added when you pass json=
    # 'Content-Type': 'application/json',
    'Accept': 'application/json, text/plain, */*',
    'Referer': 'https://shop.floralwebshop.com/',
    'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/105.0.0.0 Safari/537.36',
    'sec-ch-ua-platform': '"Windows"',
}


def saveJson(file_name, verbose=True):
    a = json.load(open(f'request_{file_name}.json', 'r'))
    print(len(a))
    products = []
    for count, i in enumerate(a):
        # if count != 30: continue
        if len(i.get('keysArray')) > 10:
            print(len(i.get('keysArray')))
        # print(i)

        response = requests.post('https://floralwebshop.com/servoy-service/rest_ws/axws/rListRows/-1/false/2', headers=headers, json=i)
        try:
            prod_list = response.json().get('content').get('list')
        except requests.exceptions.JSONDecodeError as e:
            prod_list = json.loads(response.text, strict=False).get('content').get('list')
        print(len(prod_list))
        # pp(prod_list[0])
        for prod in prod_list:
            name = prod.get('product').split(' ')
            height = '-'
            potSize = '-'
            for pot in name:
                if pot.find('Ø') != -1:
                    potSize = pot.strip().replace('Ø', '')
                elif pot.find('cm') != -1:
                    height = pot.strip()
            prodDict = {
                'ProductName': prod.get('product'),
                'ProductImage': urllib.parse.unquote(prod.get('pic')),
                'Orderper': prod.get('orderper'),
                'Color': prod.get('color'),
                'Price': prod.get('price'),
                'Pot size': potSize,
                'Height': height,
                'Origin': prod.get('origin'),
                'Quality': prod.get('quality'),
                'Productgroupname': prod.get('productgroupname'),
                'Grower': prod.get('grower'),
                'OriginCountry': prod.get('OriginCountry'),
                'Packed per': prod.get('packed per')
            }
            if verbose:
                pp(prodDict)
            products.append(prodDict)
        # exit()

    json.dump(products, open(f'{file_name}.json', 'w'), indent=4)


if __name__ == '__main__':
    # saveJson('flowers')
    saveJson('plants')
    # saveJson('decorations')
